package com.hfkj.dao;

import com.hfkj.entity.EnOilManagement;
import com.hfkj.entity.EnOilManagementExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface EnOilManagementMapper extends EnOilManagementMapperExt {
    @SelectProvider(type=EnOilManagementSqlProvider.class, method="countByExample")
    long countByExample(EnOilManagementExample example);

    @DeleteProvider(type=EnOilManagementSqlProvider.class, method="deleteByExample")
    int deleteByExample(EnOilManagementExample example);

    @Delete({
        "delete from en_oil_management",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int deleteByPrimaryKey(Integer id);

    @Insert({
        "insert into en_oil_management (`type`, transport_car_id, ",
        "transport_car_no, oil_type, ",
        "supplier, in_quantity, ",
        "out_quantity, remark, ",
        "`status`, create_user, ",
        "create_user_name, create_time, ",
        "update_user, update_user_name, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{type,jdbcType=INTEGER}, #{transportCarId,jdbcType=BIGINT}, ",
        "#{transportCarNo,jdbcType=VARCHAR}, #{oilType,jdbcType=INTEGER}, ",
        "#{supplier,jdbcType=VARCHAR}, #{inQuantity,jdbcType=DECIMAL}, ",
        "#{outQuantity,jdbcType=DECIMAL}, #{remark,jdbcType=VARCHAR}, ",
        "#{status,jdbcType=INTEGER}, #{createUser,jdbcType=BIGINT}, ",
        "#{createUserName,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateUser,jdbcType=BIGINT}, #{updateUserName,jdbcType=VARCHAR}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(EnOilManagement record);

    @InsertProvider(type=EnOilManagementSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(EnOilManagement record);

    @SelectProvider(type=EnOilManagementSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="transport_car_id", property="transportCarId", jdbcType=JdbcType.BIGINT),
        @Result(column="transport_car_no", property="transportCarNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="oil_type", property="oilType", jdbcType=JdbcType.INTEGER),
        @Result(column="supplier", property="supplier", jdbcType=JdbcType.VARCHAR),
        @Result(column="in_quantity", property="inQuantity", jdbcType=JdbcType.DECIMAL),
        @Result(column="out_quantity", property="outQuantity", jdbcType=JdbcType.DECIMAL),
        @Result(column="remark", property="remark", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_user", property="createUser", jdbcType=JdbcType.BIGINT),
        @Result(column="create_user_name", property="createUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_user", property="updateUser", jdbcType=JdbcType.BIGINT),
        @Result(column="update_user_name", property="updateUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<EnOilManagement> selectByExample(EnOilManagementExample example);

    @Select({
        "select",
        "id, `type`, transport_car_id, transport_car_no, oil_type, supplier, in_quantity, ",
        "out_quantity, remark, `status`, create_user, create_user_name, create_time, ",
        "update_user, update_user_name, update_time, ext_1, ext_2, ext_3",
        "from en_oil_management",
        "where id = #{id,jdbcType=INTEGER}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="transport_car_id", property="transportCarId", jdbcType=JdbcType.BIGINT),
        @Result(column="transport_car_no", property="transportCarNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="oil_type", property="oilType", jdbcType=JdbcType.INTEGER),
        @Result(column="supplier", property="supplier", jdbcType=JdbcType.VARCHAR),
        @Result(column="in_quantity", property="inQuantity", jdbcType=JdbcType.DECIMAL),
        @Result(column="out_quantity", property="outQuantity", jdbcType=JdbcType.DECIMAL),
        @Result(column="remark", property="remark", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_user", property="createUser", jdbcType=JdbcType.BIGINT),
        @Result(column="create_user_name", property="createUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_user", property="updateUser", jdbcType=JdbcType.BIGINT),
        @Result(column="update_user_name", property="updateUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    EnOilManagement selectByPrimaryKey(Integer id);

    @UpdateProvider(type=EnOilManagementSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") EnOilManagement record, @Param("example") EnOilManagementExample example);

    @UpdateProvider(type=EnOilManagementSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") EnOilManagement record, @Param("example") EnOilManagementExample example);

    @UpdateProvider(type=EnOilManagementSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(EnOilManagement record);

    @Update({
        "update en_oil_management",
        "set `type` = #{type,jdbcType=INTEGER},",
          "transport_car_id = #{transportCarId,jdbcType=BIGINT},",
          "transport_car_no = #{transportCarNo,jdbcType=VARCHAR},",
          "oil_type = #{oilType,jdbcType=INTEGER},",
          "supplier = #{supplier,jdbcType=VARCHAR},",
          "in_quantity = #{inQuantity,jdbcType=DECIMAL},",
          "out_quantity = #{outQuantity,jdbcType=DECIMAL},",
          "remark = #{remark,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_user = #{createUser,jdbcType=BIGINT},",
          "create_user_name = #{createUserName,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_user = #{updateUser,jdbcType=BIGINT},",
          "update_user_name = #{updateUserName,jdbcType=VARCHAR},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int updateByPrimaryKey(EnOilManagement record);
}