package com.hfkj.service.item;

import com.hfkj.entity.EnItemSegments;

import java.util.List;
import java.util.Map;

public interface EnItemSegmentsService {

    /**
     * @MethodName create
     * @Description: 创建
     * @param enItemSegments
     * @Author: Sum1Dream
     * @Date: 2025/7/1 下午4:40
     */
    void create(EnItemSegments enItemSegments) throws Exception;

    /**
     * @MethodName update
     * @Description: 更新
     * @param enItemSegments
     * @Author: Sum1Dream
     * @Date: 2025/7/1 下午4:41
     */
    void update(EnItemSegments enItemSegments);

    /**
     * @MethodName delete
     * @Description: 删除
     * @param id
     * @param fullDelete
     * @Author: Sum1Dream
     * @Date: 2025/7/1 下午4:41
     */
    void delete(Long id , Boolean fullDelete);

    /**
     * @MethodName queryDetail
     * @Description: 查询详情
     * @param id
     * @return: com.hfkj.entity.EnItemSegments
     * @Author: Sum1Dream
     * @Date: 2025/7/1 下午4:41
     */
    EnItemSegments queryDetail(Long id);

    /**
     * @MethodName queryDetailByMap
     * @Description: 根据map查询详情
     * @param map
     * @return: com.hfkj.entity.EnItemSegments
     * @Author: Sum1Dream
     * @Date: 2025/7/1 下午4:41
     */
    EnItemSegments queryDetailByMap(Map<String , Object> map);

    /**
     * @MethodName getList
     * @Description: 查询列表
     * @param map
     * @return: java.util.List<com.hfkj.entity.EnItemSegments>
     * @Author: Sum1Dream
     * @Date: 2025/7/1 下午4:41
     */
    List<EnItemSegments> getList(Map<String , Object> map);
}
