package com.hfkj.service.item;

import com.hfkj.entity.EnServiceCompany;

import java.util.List;
import java.util.Map;

public interface EnServiceCompanyService {

    /**
     * @MethodName create
     * @Description: 新增
     * @param enServiceCompany
     * @Author: Sum1Dream
     * @Date: 2025/7/9 下午5:41
     */
    void create(EnServiceCompany enServiceCompany) throws Exception;

   /**
    * @MethodName update
    * @Description:修改
    * @param enServiceCompany
    * @Author: Sum1Dream
    * @Date: 2025/7/9 下午5:41
    */
    void update(EnServiceCompany enServiceCompany);

    /**
     * @MethodName delete
     * @Description:删除
     * @param id
     * @param fullDelete
     * @Author: Sum1Dream
     * @Date: 2025/7/9 下午5:41
     */
    void delete(Long id , Boolean fullDelete);

    /**
     * @MethodName queryDetail
     * @Description:查询详情
     * @param id
     * @return: com.hfkj.entity.EnServiceCompany
     * @Author: Sum1Dream
     * @Date: 2025/7/9 下午5:41
     */
    EnServiceCompany queryDetail(Long id);

    /**
     * @MethodName queryDetailByMap
     * @Description:根据多条件查询详情
     * @param map
     * @return: com.hfkj.entity.EnServiceCompany
     * @Author: Sum1Dream
     * @Date: 2025/7/9 下午5:41
     */
    EnServiceCompany queryDetailByMap(Map<String , Object> map);


    /**
     * @MethodName getList
     * @Description:查询列表
     * @param map
     * @return: java.util.List<com.hfkj.entity.EnServiceCompany>
     * @Author: Sum1Dream
     * @Date: 2025/7/9 下午5:41
     */
    List<EnServiceCompany> getList(Map<String , Object> map);

}
