package com.hfkj.service.item.impl;

import com.hfkj.dao.EnSerCompanySgRelMapper;
import com.hfkj.entity.EnSerCompanySgRel;
import com.hfkj.entity.EnSerCompanySgRelExample;
import com.hfkj.service.item.EnSerCompanySgRelService;
import org.apache.commons.collections4.MapUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service("enSerCompanySgRelService")
public class EnSerCompanySgRelServiceImpl implements EnSerCompanySgRelService {

    @Resource
    private EnSerCompanySgRelMapper enSerCompanySgRelMapper;

    @Override
    public void create(EnSerCompanySgRel enSerCompanySgRel) {
        enSerCompanySgRelMapper.insert(enSerCompanySgRel);
    }

    @Override
    public void update(EnSerCompanySgRel enSerCompanySgRel) {
        enSerCompanySgRelMapper.updateByPrimaryKey(enSerCompanySgRel);
    }

    @Override
    public void delete(Long id, Boolean fullDelete) {
        if (fullDelete) {
            enSerCompanySgRelMapper.deleteByPrimaryKey(id);
        } else {
            EnSerCompanySgRel enSerCompanySgRel = queryDetail(id);
            enSerCompanySgRel.setStatus(0);
            enSerCompanySgRel.setUpdateTime(new Date());
            update(enSerCompanySgRel);
        }
    }

    @Override
    public void deleteAllByCompanyId(Long companyId, Boolean fullDelete , Long createUser) {
        EnSerCompanySgRelExample example = new EnSerCompanySgRelExample();
        EnSerCompanySgRelExample.Criteria criteria  = example.createCriteria();
        criteria.andCompanyIdEqualTo(companyId).andStatusEqualTo(1);

        List<EnSerCompanySgRel> list = enSerCompanySgRelMapper.selectByExample(example);

        for (EnSerCompanySgRel enSerCompanySgRel : list) {
            delete(enSerCompanySgRel.getId() , fullDelete);
        }

    }

    @Override
    public EnSerCompanySgRel queryDetail(Long id) {
        return enSerCompanySgRelMapper.selectByPrimaryKey(id);
    }

    @Override
    public EnSerCompanySgRel queryDetailByMap(Map<String, Object> map) {
        EnSerCompanySgRelExample example = new EnSerCompanySgRelExample();
        EnSerCompanySgRelExample.Criteria criteria  = example.createCriteria();

        if (StringUtils.isNotBlank(MapUtils.getString(map, "companyName"))) {
            criteria.andCompanyNameLike("%"+MapUtils.getString(map, "companyName")+"%");
        }
        if (StringUtils.isNotBlank(MapUtils.getString(map, "segmentName"))) {
            criteria.andSegmentNameLike("%"+MapUtils.getString(map, "segmentName")+"%");
        }
        if (MapUtils.getLong(map , "companyId") != null) {
            criteria.andCompanyIdEqualTo(MapUtils.getLong(map , "companyId"));
        }
        if (MapUtils.getLong(map , "segmentId") != null) {
            criteria.andSegmentIdEqualTo(MapUtils.getLong(map , "segmentId"));
        }
        if (MapUtils.getLong(map, "createUser") != null) {
            criteria.andCreateUserEqualTo(MapUtils.getLong(map, "createUser"));
        }
        if (MapUtils.getInteger(map, "status") != null) {
            criteria.andStatusEqualTo(MapUtils.getInteger(map, "status"));
        }else {
            criteria.andStatusNotEqualTo(0);
        }
        if (MapUtils.getLong(map , "id") != null) {
            criteria.andIdEqualTo(MapUtils.getLong(map , "id"));
        }

        List<EnSerCompanySgRel> list = enSerCompanySgRelMapper.selectByExample(example);

        return list.isEmpty() ? null : list.get(0);
    }

    @Override
    public List<EnSerCompanySgRel> getList(Map<String, Object> map) {
        EnSerCompanySgRelExample example = new EnSerCompanySgRelExample();
        EnSerCompanySgRelExample.Criteria criteria  = example.createCriteria();

        if (StringUtils.isNotBlank(MapUtils.getString(map, "companyName"))) {
            criteria.andCompanyNameLike("%"+MapUtils.getString(map, "companyName")+"%");
        }
        if (StringUtils.isNotBlank(MapUtils.getString(map, "segmentName"))) {
            criteria.andSegmentNameLike("%"+MapUtils.getString(map, "segmentName")+"%");
        }
        if (MapUtils.getLong(map , "companyId") != null) {
            criteria.andCompanyIdEqualTo(MapUtils.getLong(map , "companyId"));
        }
        if (MapUtils.getLong(map , "segmentId") != null) {
            criteria.andSegmentIdEqualTo(MapUtils.getLong(map , "segmentId"));
        }
        if (MapUtils.getLong(map, "createUser") != null) {
            criteria.andCreateUserEqualTo(MapUtils.getLong(map, "createUser"));
        }
        if (MapUtils.getInteger(map, "status") != null) {
            criteria.andStatusEqualTo(MapUtils.getInteger(map, "status"));
        }else {
            criteria.andStatusNotEqualTo(0);
        }
        if (MapUtils.getLong(map , "id") != null) {
            criteria.andIdEqualTo(MapUtils.getLong(map , "id"));
        }
        return enSerCompanySgRelMapper.selectByExample(example);
    }
}
